/*****************************************************************************

  FileName:		Q850.h

  Contents:		ITU-T Q.850 cause codes

  License/Copyright:

  Copyright (c) 2008, Stefan Knoblich, axsentis GmbH. All rights reserved.
  email: s.knoblich@axsentis.de

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.
    * Neither the name of the axsentis GmbH nor the names of its contributors
      may be used to endorse or promote products derived from this software
      without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
  POSSIBILITY OF SUCH DAMAGE.
*****************************************************************************/

#ifndef _Q850_H_
#define _Q850_H_

/**
 * ITU-T Q.850 cause codes
 *
 * @note	Not complete!
 */
enum {
	Q850_CAUSE_NONE = 0,
	Q850_CAUSE_UNALLOCATED = 1,
	Q850_CAUSE_NO_ROUTE_TRANSIT_NET = 2,
	Q850_CAUSE_NO_ROUTE_DESTINATION = 3,
	Q850_CAUSE_CHANNEL_UNACCEPTABLE = 6,
	Q850_CAUSE_CALL_AWARDED_DELIVERED = 7,
	Q850_CAUSE_NORMAL_CLEARING = 16,
	Q850_CAUSE_USER_BUSY = 17,
	Q850_CAUSE_NO_USER_RESPONSE = 18,
	Q850_CAUSE_NO_ANSWER = 19,
	Q850_CAUSE_SUBSCRIBER_ABSENT = 20,
	Q850_CAUSE_CALL_REJECTED = 21,
	Q850_CAUSE_NUMBER_CHANGED = 22,
	Q850_CAUSE_REDIRECTION_TO_NEW_DESTINATION = 23,
	Q850_CAUSE_EXCHANGE_ROUTING_ERROR = 25,
	Q850_CAUSE_DESTINATION_OUT_OF_ORDER = 27,
	Q850_CAUSE_INVALID_NUMBER_FORMAT = 28,
	Q850_CAUSE_FACILITY_REJECTED = 29,
	Q850_CAUSE_RESPONSE_TO_STATUS_ENQUIRY = 30,
	Q850_CAUSE_NORMAL_UNSPECIFIED = 31,
	Q850_CAUSE_NORMAL_CIRCUIT_CONGESTION = 34,
	Q850_CAUSE_NETWORK_OUT_OF_ORDER = 38,
	Q850_CAUSE_NORMAL_TEMPORARY_FAILURE = 41,
	Q850_CAUSE_SWITCH_CONGESTION = 42,
	Q850_CAUSE_ACCESS_INFO_DISCARDED = 43,
	Q850_CAUSE_REQUESTED_CHAN_UNAVAIL = 44,
	Q850_CAUSE_PRE_EMPTED = 45,
	Q850_CAUSE_FACILITY_NOT_SUBSCRIBED = 50,
	Q850_CAUSE_OUTGOING_CALL_BARRED = 52,
	Q850_CAUSE_INCOMING_CALL_BARRED = 54,
	Q850_CAUSE_BEARERCAPABILITY_NOTAUTH = 57,
	Q850_CAUSE_BEARERCAPABILITY_NOTAVAIL = 58,
	Q850_CAUSE_SERVICE_UNAVAILABLE = 63,
	Q850_CAUSE_BEARERCAPABILITY_NOTIMPL = 65,
	Q850_CAUSE_CHAN_NOT_IMPLEMENTED = 66,
	Q850_CAUSE_FACILITY_NOT_IMPLEMENTED = 69,
	Q850_CAUSE_SERVICE_NOT_IMPLEMENTED = 79,
	Q850_CAUSE_INVALID_CALL_REFERENCE = 81,
	Q850_CAUSE_INCOMPATIBLE_DESTINATION = 88,
	Q850_CAUSE_INVALID_MSG_UNSPECIFIED = 95,
	Q850_CAUSE_MANDATORY_IE_MISSING = 96,
	Q850_CAUSE_MESSAGE_TYPE_NONEXIST = 97,
	Q850_CAUSE_WRONG_MESSAGE = 98,
	Q850_CAUSE_IE_NONEXIST = 99,
	Q850_CAUSE_INVALID_IE_CONTENTS = 100,
	Q850_CAUSE_WRONG_CALL_STATE = 101,
	Q850_CAUSE_RECOVERY_ON_TIMER_EXPIRE = 102,
	Q850_CAUSE_MANDATORY_IE_LENGTH_ERROR = 103,
	Q850_CAUSE_PROTOCOL_ERROR = 111,
	Q850_CAUSE_INTERWORKING = 127
};

/**
 * Q850CauseGetName
 * @brief	Convert cause code to string
 * @param[in]	cause	Numerical cause code
 * @return	String
 */
const char *Q850CauseGetName(const int cause);

#endif
